/*
    
    Ec     Copyright (C)   2001 Marc Dechico

    ec_eva.c :  compute the datas collected during the simulation 
                (exploration of the game tree) 
		automat to find bugs in the engine (play random)
		automat to compare methode of evaluation 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

#include "ec_data.h"

extern void aff_cal_en_cou_wra (int i_not_cpt_mvt_ini);
extern void aff_mes_uti_wra (int i_mes_num); 

/*******************************************************************************/
/* Donnes utilise pour faire jouer l'ordinateur contre lui mme et comparer
   mthode d'valuation */
/* description partie */
struct des_par {
  int ver[2];   		/* Numero de la version  */
  int (*pf_eva[2])(void); 	/* Pointeur sue la fct d'valuation */
  int pro[2];			/* profondeur de simu  utilise*/
  int inc[2];			/* incrment de la simu */
  int mvt_ini;			/* mvr initial */
  int ver_bla;			/* Versin utilis pour les blancs */
  int ver_noi;			/* Versin utilis pour les blancs */
  char	 cam_gag;			/* Camp gagnant */
} des_par;
int (*pf_eva_cam[2]) (void) ;	/* Fct dvaluation par cam */

/*******************************************************************************/
/* Evaluation mouvement */
void cho_coe_01 (void)
{
  
  st_eva_sit.ti_coe_pon[nbr_mvt]		=0;

  st_eva_sit.ti_coe_pon[nbr_mat]		=5;
  st_eva_sit.ti_coe_pon[nbr_mat_rf]		=10;
  st_eva_sit.ti_coe_pon[nbr_mat_inc]		=1;

  if (st_eva_sit.i_not_for < -230)
    {
      st_eva_sit.ti_coe_pon[nbr_pat]		=7;
      st_eva_sit.ti_coe_pon[nbr_pat_rf]		=15;
      st_eva_sit.ti_coe_pon[nbr_pat_inc]	=3;
    }
  else
  {
      st_eva_sit.ti_coe_pon[nbr_pat]		=0;
      st_eva_sit.ti_coe_pon[nbr_pat_rf]		=0;
      st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;
  }
  st_eva_sit.ti_coe_pon[mob_pie]		=3;
  st_eva_sit.ti_coe_pon[cou_pie]		=3;
  st_eva_sit.ti_coe_pon[nbr_fou]		=3;

}
void cho_coe_02 (void)
{
  /*pourrait calculer directement coef  partir note situation */ 
  /* il faudrait mouliner et faire des statistiques pour vrifier */
  /* la vracit  des coef choisis */

  /* pour qu'une note soit prepodrante il faut que sont coef soit 
     superieur  la somme des coef des autre notes                */
  
  st_eva_sit.ti_coe_pon[nbr_mvt]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat]		=3;
  st_eva_sit.ti_coe_pon[nbr_pat]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat_rf]		=3;
  st_eva_sit.ti_coe_pon[nbr_pat_rf]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat_inc]		=2;
  st_eva_sit.ti_coe_pon[nbr_pat_inc]		=0;
  st_eva_sit.ti_coe_pon[mob_pie]		=1;
  st_eva_sit.ti_coe_pon[cou_pie]		=0;
  st_eva_sit.ti_coe_pon[nbr_fou]		=0;

}
int  eva_mei_mvt(void)
{
  int i_mei_mvt;

  i_mei_mvt= (*pf_eva)();

  return i_mei_mvt;
}

int  eva_mei_mvt_01(void)
{	
  /* traitement des donnes */
  tra_don ();

  /* Choix coef de ondration */
  cho_coe_01();

  /* pondration des donnes suivant l'importance accorde  pour calcul note globale */
  pon_not();

  /* Tri des donnes par not recadre pondre */
  tri_mvt_rec();

  /* controle cas d'galit du  reproduction pos piece */
  return ctl_ega();

}

int  eva_mei_mvt_02(void)
{	
   /* traitement des donnes */
  tra_don ();

  /* Choix coef de ondration */
  cho_coe_02();

  /* pondration des donnes suivant l'importance accorde  pour calcul note globale */
  pon_not();

  /* Tri des donnes par not recadre pondre */
  tri_mvt_rec();

  /* controle cas d'galit du  reproduction pos piece */
  return ctl_ega();

}
int  eva_mei_mvt_test(void)
{
  /* pour detecter d'vantuels bugs */ 
  /* le traitement est le mme sauf que je choisi un mvt au hasard au lieu 
     de celui considr comme le meilleur */  

  int mvt_ini;
  double d_rand;
   /* traitement des donnes */
  tra_don ();

  /* Choix coef de ondration */
  cho_coe_02();

  /* pondration des donnes suivant l'importance accorde  pour calcul note globale */
  pon_not();

  /* Tri des donnes par not recadre pondre */
  tri_mvt_rec();

  /* retourne un mvt initial pris au hasard...  */
  d_rand=rand();   /* remplace random() pour compatibilit BORLAND */
  mvt_ini= (unsigned int)(i_not_cpt_mvt_ini *d_rand/RAND_MAX);
  return mvt_ini;

}
void not_mvt_ini_raz(int i_pro_sim,int i_inc_pro_sim)
{
  int x,y;

  ST_NOT_MVT_INI *pts_mvt;

  enum typ_not tn;
  for(x=0;x<MVT_INI;x++)
    {
      pts_mvt = &ts_not_mvt_ini[x];

      pts_mvt->i_cam		=pts_hst_pro->i_cam;
      pts_mvt->i_cam_adv	=pts_hst_pro->i_cam_adv;
      pts_mvt->i_pro_sim	=i_pro_sim;
      pts_mvt->i_inc_pro_sim	=i_inc_pro_sim;
      
      for (tn = 0; tn <NBR_TYP_NOT;tn++)
	{
	  /* remise a zero des cumuls provenant de hst et autres*/
	  pts_mvt->tst_not[tn].f_not_cam_bru[BLANC]=0;
	  pts_mvt->tst_not[tn].f_not_cam_bru[NOIR]=0;
	  pts_mvt->tst_not[tn].f_not_cam_pon[BLANC]=0;
	  pts_mvt->tst_not[tn].f_not_cam_pon[NOIR]=0;
	  pts_mvt->tst_not[tn].f_not_dif_pon=0;
	  pts_mvt->tst_not[tn].i_not_pon_rec=0;
	}


      for(y=0; y<PRO_SIM_INF_MAX; y++)
	{
	  /* Remise  zero des infos collect dans hst  pro*/
	  tst_pro_sta[x][y].i_cam=0;
	  tst_pro_sta[x][y].i_inc=0;
	  for (tn = 0; tn <NBR_TYP_NOT;tn++)
	    tst_pro_sta[x][y].f_dat_pro[tn]=0;

	}
    }
  /* raz valeur d'valuation de la situation */
  st_eva_sit.ti_tot_for	[BLANC]	=0;
  st_eva_sit.ti_tot_for	[NOIR ]	=0;
  st_eva_sit.i_not_for		=0;

  st_eva_sit.tf_cou	[BLANC]	=0;
  st_eva_sit.tf_cou	[NOIR ]	=0;
  st_eva_sit.f_cou		=0;
  
  st_eva_sit.tf_mob	[BLANC]	=0;
  st_eva_sit.tf_mob	[NOIR ]	=0;
  st_eva_sit.f_not_mob		=0;
 
  for (tn = 0; tn <NBR_TYP_NOT;tn++)
    {
      st_eva_sit.ti_coe_pon[tn]		=0;
      st_eva_sit.tst_int_not[tn].max 	=0;
      st_eva_sit.tst_int_not[tn].min 	=0;
    }
}
void hst_cpt_raz(void)
{
  int pro;
  int rap_for_ini;
  for(pro=0;pro<PRO_HST;pro++)
    {
      ts_hst_pro[pro].uli_cpt_mat	=0;
      ts_hst_pro[pro].uli_cpt_pat	=0;
      ts_hst_pro[pro].uli_cpt_mat_rf	=0;
      ts_hst_pro[pro].uli_cpt_pat_rf	=0;
      ts_hst_pro[pro].uli_nbr_fou	=0;
      ts_hst_pro[pro].uli_cpt_cou	=0;
      ts_hst_pro[pro].i_eff_bor		=0;

    }
  /* une prise en bas de l'arbre explore n'est prise en compte que */
  /* si le camp la faisant est celui contre qui la simu joue */
  /* cad on sur-evalue les capacit de l'adversaire */
  /* et on sous-evalue ses propres capacites */

  if(pts_hst_pro->i_cam == ts_hst_pro[i_pro_sim_max_inf].i_cam)

    /* bug : cette option semble ne pas tre efficace pour le jeux */
    /* il faut prevoir une solution de remplacement */
    /*  ts_hst_pro[i_pro_sim_max_inf].i_eff_bor= 1;*/
    ts_hst_pro[i_pro_sim_max_inf].i_eff_bor= 0;
  else
     
    ts_hst_pro[i_pro_sim_max_inf].i_eff_bor= 0;

  /* precalculation du rapport de force initial */
  /* pour eviter un accs tableau par le camp */ 
  /* rapport de force camp 0 = - rap de for camp 1 */
  /* opti : recalcul en fin de simu pour evaluation */

  rap_for_ini 
    =
    eva_for_cam(ts_hst_pro[i_pro_act].i_cam)
    -
    eva_for_cam(ts_hst_pro[i_pro_act].i_cam_adv);

  for (pro=i_pro_act+1;pro <= i_pro_sim_max_inf;pro++)   
    {
      rap_for_ini *=-1;
      ts_hst_pro[pro].i_rap_for_ini = rap_for_ini;
    }
}


void not_cal (void)
{
  /* Stockage des donnes dans structure du mvt initial                     */

  struct st_pie		*pts_pie_cal;	/* ptr tableau struct pice */
  ST_NOT_MVT_INI *pts_mvt;
   int x,y; 				/* index pour transfert de nbr coups */
  /* de hst dans not mvt ini */ 
  int inc;
  pts_mvt = &ts_not_mvt_ini[i_not_cpt_mvt_ini];
   
  /* memorise le numro de mvt */
  pts_mvt->i_num_mvt =i_not_cpt_mvt_ini;

  /* memorise l'Id */
  pts_mvt->i_Id = pts_hst_pro_p->i_Id;

  /* memorise le type du mouvement */
  pts_mvt->i_typ_mvt =  pts_hst_pro_p->i_typ_mvt;
  
  /* memorise la position de depart */
  pts_mvt->i_pos_ori_n = pts_hst_pro_p->i_pos_ori_n;

  /* memorise la position d'arrive */
  pts_mvt->i_pos_arr_n =  pts_hst_pro_p->i_pos_n;
  
  /* initialisation des pionteurs sur  pie */
  pts_pie_cal = pts_hst_pro_p->pts_pie_pc + pts_hst_pro_p->i_Id;

  /* memorise le libelle */
  pts_mvt->c_lib_pie = pts_pie_cal->c_lib_pie;

  /* memorise de la note  */
  pts_mvt->i_not_pri = pts_hst_pro_p->i_not ;

  /* Stockage des infos de hst dans mvt ini pour retraitement ulterieur */
  for(x=i_pro_sim_act,y=0; x<=i_pro_sim_max_inf; x++,y++)
    {
      /* Memorisation du camp */
      tst_pro_sta[i_not_cpt_mvt_ini][y].i_cam =ts_hst_pro[x].i_cam;
		
      /* Memorisation si increment  */
      if  (x>i_pro_sim_max_sup)
	inc=1;
      else
	inc =0;
      tst_pro_sta[i_not_cpt_mvt_ini][y].i_inc = inc;

      /* transfert nombre de mvt */
 
       tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mvt] 		
	=
	ts_hst_pro[x].uli_cpt_cou;

      ts_hst_pro[x].uli_cpt_cou = 0;
		
      /* transfert npmbre de mat */

      if(inc == 0)	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_mat;
      else	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat_inc] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_mat;

      ts_hst_pro[x].uli_cpt_mat = 0;
		
      /* transfert npmbre de pat */
      if(inc == 0 )	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat;
      else
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat_inc] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat;

      ts_hst_pro[x].uli_cpt_pat = 0;
	
      /* transfert npmbre de mat raport de force >=0 */

      if(inc == 0 )	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat_rf] 	 		
	  =	
	  ts_hst_pro[x].uli_cpt_mat_rf;

      ts_hst_pro[x].uli_cpt_mat_rf = 0;
		
      /* transfert npmbre de pat rapoort de force >=0 */
      if(inc == 0)	 
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat_rf] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat_rf;
      ts_hst_pro[x].uli_cpt_pat_rf = 0;

      /* transfert nombre de fourchette  */
		if(inc == 0)
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_fou] 	 		
	  =
	  ts_hst_pro[x].uli_nbr_fou;
      ts_hst_pro[x].uli_nbr_fou  = 0;
	
    }
 
  if	(
	 i_pro_sim_max_sup!= i_pro_act+2
	 ||
	 i_pro_sim_max_inf!= i_pro_act+2
	 )
    {
    aff_cal_en_cou_wra(i_not_cpt_mvt_ini);
  /*test*/
    /*aff_ech(0);aff_pie(0);*/

    }
  
  /* interuption de la simulation si mat detect */
  if (pts_hst_pro_p->i_mat==1) sto_sim();

  /* increment du compteur de mouvement */
  i_not_cpt_mvt_ini++;

}


void tra_don (void)
{
  /* Traitement des donnes pour evaluation du meilleur coup */
  int cpt_mvt;
  enum typ_not  cpt_typ_not;
  int i_cam;
  int i_cam_adv;
  ST_NOT_MVT_INI *pts_mvt;

  i_cam 	=ts_hst_pro[i_pro_act+1].i_cam;
  i_cam_adv 	=ts_hst_pro[i_pro_act+1].i_cam_adv;

  /* valuation de la situation */
  eva_sit(i_cam,i_cam_adv);
	

  /* traitement des donnes collectes dans hst */
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
      pts_mvt = &ts_not_mvt_ini[cpt_mvt];


      /* cumule valeurs  profondeur	  	*/
      /* calcul diffrence pc - ca		*/
      /* memorisation mini maxi     		*/
      
      /*dans ce cas seulement  ne pondere pas le nombre de mvt par lui mme */
      cum_not(nbr_mvt,pts_mvt);
      
      cum_not_pon(nbr_mat,pts_mvt);
      cum_not_pon(nbr_mat_inc,pts_mvt);
      cum_not_pon(nbr_pat,pts_mvt);
      cum_not_pon(nbr_pat_inc,pts_mvt);
      cum_not_pon(nbr_mat_rf,pts_mvt);
      cum_not_pon(nbr_pat_rf,pts_mvt);
      cum_not_pon(nbr_fou,pts_mvt);
      
      /* calcul couverture et rptition situation  */
      cal_cou_rep(pts_mvt);
		
      /* clacul de la mobilit */
      cal_mob(pts_mvt);     
 

    } /* fin de la boucle cpt mvt initial */

  /* calcul des notes recadres */
  for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
    {
      rec_not_mvt(cpt_typ_not);
    }
}
void cal_cou_rep (ST_NOT_MVT_INI *pts_mvt)
{
/* calcul de la couverture et rptitin situation */
  int i_msg;

  /* deplace la piece */
  i_msg = jou (
       pts_mvt->i_pos_ori_n,
       pts_mvt->i_pos_arr_n,
       pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt)
       ) ;
  if(i_msg<0)
    { 	
      printf("\n%c:",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf(" %s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      aff_mes_uti_wra(i_msg);
      return;
    }
  else
    {   
 
      /* sauvegarde du nombre de rptition de situation d'echiquier */
      pts_mvt->i_nbr_rep_sit  = ctl_rep_pos(i_pro_act);
   	
      /* calcul couverture */
      pts_mvt->tst_not[cou_pie].f_not_cam_pon[BLANC] = eva_cou_cam(BLANC);
      pts_mvt->tst_not[cou_pie].f_not_cam_pon[NOIR ] = eva_cou_cam(NOIR );
      cal_dif_max(cou_pie,pts_mvt);

      /*restore la piece */ 
      ann_cou();
    }
  return;
}
void cal_mob (ST_NOT_MVT_INI *pts_mvt)
{
  float mob1,mob2;
  /* calcul de la mobilit par camp */
  
 
  mob1= tst_pro_sta[pts_mvt->i_num_mvt][0].f_dat_pro[nbr_mvt];
  if ( mob1 != 0)
    mob2 =  tst_pro_sta[pts_mvt->i_num_mvt][1].f_dat_pro[nbr_mvt]
      / 
      mob1;
                                          
  else 
    mob2 =0;

  pts_mvt->tst_not[mob_pie].f_not_cam_pon[ tst_pro_sta[pts_mvt->i_num_mvt][0].i_cam]
    = mob1;
  pts_mvt->tst_not[mob_pie].f_not_cam_pon[ tst_pro_sta[pts_mvt->i_num_mvt][1].i_cam]
    = mob2;

  cal_dif_max(mob_pie,pts_mvt);

}

void cum_not_pon (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)
{
  /* org: revoir nom de fonction */
  /* retraite info provenant de hst_pro et cal diffrence camp -camp adverse
     zt aussi mise  jour des maxi mini */
  int i_cpt_pro;
  float f_pon;
  int i_cam;
  float f_nbr_mvt;

  /* Raz des cumuls */
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[NOIR ]=0;

   pts_mvt->tst_not[e_typ_not].f_not_cam_bru[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_bru[NOIR ]=0;
  
  for(i_cpt_pro=0;i_cpt_pro <PRO_SIM_INF_MAX; i_cpt_pro++)
    {
      /* Cumul par camp  des donnes stock par profondeur  en pondrant
       avec le nombre de mvts de la pronfondeur d'acquisition */
      f_nbr_mvt =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[nbr_mvt];
      if(f_nbr_mvt != 0)
	f_pon =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not]
	  / f_nbr_mvt;
      else
	f_pon=0;

      i_cam =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].i_cam;
      pts_mvt->tst_not[e_typ_not].f_not_cam_pon[i_cam]+=f_pon;

      /* Cumul par camp  des donnes stock par profondeur sans pondrer */
      pts_mvt->tst_not[e_typ_not].f_not_cam_bru[i_cam]+=
	 tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not];
    }
  
  cal_dif_max(e_typ_not,pts_mvt);

}
void cum_not (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* retraite info provenant de hst_pro et cal diffrence camp -camp adverse
     zt aussi mise  jour des maxi mini */
  int i_cpt_pro;
  int i_cam;

  /* Raz des cumuls */
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[NOIR ]=0;
  
  /* Cumul par camp  des donnes stock par profondeur  en pondrant */
  for(i_cpt_pro=0;i_cpt_pro < PRO_SIM_INF_MAX; i_cpt_pro++)
    {

      i_cam =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].i_cam;
      pts_mvt->tst_not[e_typ_not].f_not_cam_pon[i_cam]+=
	 tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not];

    }
  
  cal_dif_max(e_typ_not,pts_mvt);

}

void cal_dif_max (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* Calcul de la difference camp propre  - camp adverse  et mise  jour des maxis */

  /* Calcul de la diffrence */
  pts_mvt->tst_not[e_typ_not].f_not_dif_pon=
    pts_mvt->tst_not[e_typ_not].f_not_cam_pon[pts_mvt->i_cam]
    -
    pts_mvt->tst_not[e_typ_not].f_not_cam_pon[pts_mvt->i_cam_adv];
  
  /* Mise  jour des maxi mini */
  cal_max(e_typ_not,pts_mvt);

}
void cal_max (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* Mise  jour des maxi mini */
  if ( pts_mvt->tst_not[e_typ_not].f_not_dif_pon > st_eva_sit.tst_int_not[e_typ_not].max)
    st_eva_sit.tst_int_not[e_typ_not].max=  pts_mvt->tst_not[e_typ_not].f_not_dif_pon;    

  if ( pts_mvt->tst_not[e_typ_not].f_not_dif_pon < st_eva_sit.tst_int_not[e_typ_not].min)
    st_eva_sit.tst_int_not[e_typ_not].min=  pts_mvt->tst_not[e_typ_not].f_not_dif_pon;    


}

void rec_not_mvt (enum typ_not e_typ_not)
{
  /* recadrage de la note en fonction des mini maxi */
  int cpt_mvt;
  ST_NOT_MVT_INI *pts_mvt;

  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
		pts_mvt = &ts_not_mvt_ini[cpt_mvt];

      pts_mvt->tst_not[e_typ_not].i_not_pon_rec 
	=
	rec_not(  st_eva_sit.tst_int_not[e_typ_not].max,
		  st_eva_sit.tst_int_not[e_typ_not].min,
		  pts_mvt->tst_not[e_typ_not].f_not_dif_pon);
 
    }

}
/* recadrage note */ 
int rec_not (float max,float min, float val)
{
  float x = 0;
  x = max-min;
  if (x == 0)
    return 0;
  else
    return (int) ((val-min)/x*100);

}
void  tri_mvt_rec (void)
{
  /* tri en ordre decroissant des mvt selon total recadre pondr */
  int cpt_1,cpt_2;
 ST_NOT_MVT_INI *pts_mvt;

  /* chargement table d'indexe avec adresse mvt */
  for (cpt_1 = 0; cpt_1 < MVT_INI; cpt_1++)
	 {
		if (cpt_1 < i_not_cpt_mvt_ini)
	/* pointeur sur mouvement courant*/
	ts_tri_mvt_ini[cpt_1].pts_tri_rec = &ts_not_mvt_ini[cpt_1];
      else
	ts_tri_mvt_ini[cpt_1].pts_tri_rec = NULL;

	 }
  /* tri dcroissant  des mvt avec note recadre pondre totale */ 
   for (cpt_1 = 0; cpt_1 < i_not_cpt_mvt_ini; cpt_1++)
	 {
      for (cpt_2 = cpt_1+1; cpt_2 < i_not_cpt_mvt_ini; cpt_2++)
	{
	  if(
	     ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_not_pri
	     <
	     ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_not_pri
	     ||
	     (
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_not_pri
	      ==
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_not_pri
	      &&
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->f_tot_rec_pon 
	      <
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->f_tot_rec_pon
	      ) 
	     )
	    {
	      pts_mvt= ts_tri_mvt_ini[cpt_2].pts_tri_rec;
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec=ts_tri_mvt_ini[cpt_1].pts_tri_rec;
			ts_tri_mvt_ini[cpt_1].pts_tri_rec=pts_mvt;
		 }
	}
    }
}

void pon_not(void)
{
  /* org: nom mal choisi car confusion avec pondration par nbr mvt 
     dans ce cas on pondere avec coeficiant */
  int cpt_mvt;
 ST_NOT_MVT_INI *pts_mvt;

  int pon_tot	=0;
  float tot_rec	=0;
  float tot_dif	=0;
  int cpt_typ_not;

  /* cumul des coeficient */
  for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
	 pon_tot+=st_eva_sit.ti_coe_pon[cpt_typ_not] ;

  /* cumul des notes pondres */
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
	 {
		/* pointeur sur mouvement courant */
		pts_mvt = &ts_not_mvt_ini[cpt_mvt];

		{
	tot_dif=0;
	tot_rec=0;
	for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
	  {
		 tot_dif  += (float) pts_mvt->tst_not[cpt_typ_not].f_not_dif_pon
			*
			(float) st_eva_sit.ti_coe_pon[cpt_typ_not];

		 tot_rec  += (float) pts_mvt->tst_not[cpt_typ_not].i_not_pon_rec
			*
			(float) st_eva_sit.ti_coe_pon[cpt_typ_not];

	  }
	if(pon_tot !=0 )
	  {
		 pts_mvt->f_tot_dif_pon = (float)	(tot_dif  / (float) pon_tot);
		 pts_mvt->f_tot_rec_pon = (float)	(tot_rec  / (float) pon_tot);
	  }
	else
	  {
		 pts_mvt->f_tot_dif_pon = 0;
		 pts_mvt->f_tot_rec_pon = 0;
	  }
		}
	 }
}

void eva_sit(int i_cam, int i_cam_adv)
{
/* rapport de force */
	st_eva_sit.ti_tot_for[BLANC] = eva_for_cam(BLANC);
	st_eva_sit.ti_tot_for[NOIR ] = eva_for_cam(NOIR );
	st_eva_sit.i_not_for = st_eva_sit.ti_tot_for[i_cam] -st_eva_sit.ti_tot_for[i_cam_adv];
/* couverture des pieces */
	st_eva_sit.tf_cou[BLANC]=eva_cou_cam(BLANC);
	st_eva_sit.tf_cou[NOIR] =eva_cou_cam(NOIR);
	st_eva_sit.f_cou = st_eva_sit.tf_cou[i_cam] -st_eva_sit.tf_cou[i_cam_adv];

}
int  eva_for_cam(int i_cam)
{
  int i_for =0;
  struct st_pie  *pts_pie_eva;      	/* ptr sur tbl structure piece */


  pts_pie_eva = tpts_pie[i_cam];
  pts_pie_eva =  tpts_pie[i_cam]+pts_pie_eva->i_pie_sui;

	/* Cumul la force de chaque piece i_tot_for */
  while (1)
	 {
		i_for +=pts_pie_eva->i_for;
		if(pts_pie_eva->i_pie_sui ==17) break;
		pts_pie_eva =tpts_pie[i_cam]+pts_pie_eva->i_pie_sui;
	 }
  return i_for;
}

float eva_cou_cam (int i_cam)
{
  struct st_pie *pts_pie_ct;
  float i_cou_glo = 0;      
 /* Couverture globale*/
 /* calcul couverture part piece propre cam */
  pts_pie_ct=tpts_pie[i_cam] ;

  for (pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
		 ;
		 pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)

	 {
		if (pts_pie_ct->c_typ_pie != 'R')
	i_cou_glo = i_cou_glo +  eva_cou_pie (pts_pie_ct->i_pos_n,i_cam );

		if (pts_pie_ct->i_pie_sui==17) break;

	 }

  return i_cou_glo;
}
float eva_cou_pie (int nn,int i_cam)
{
  struct st_pie *pts_pie_ct;
  float i_cou =0 ;
  int i_cou_ok=0;   /* si au moins une piece couvre la position */

  /* calcul couverture de la piece en position nn
	  par les pieces du camp  du camp  i_cam */
  pts_pie_ct=tpts_pie[i_cam] ;


  for (pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
		 ;
		 pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)

	 {
		if(   (*pts_pie_ct->pf_ctl_par) (pts_pie_ct->i_pos_n,nn )   )
	{
	  /* si piece couverte par au moins une piece on augment la note de couverture
		  de la force de la piece couverte pour favoriser la couverture des pieces
		  les plus importantes*/
	  /* on augmente la note de l'inverse de la force de la piece faisant la couverture
		  pour favoriser la couverture par des pices de moindre importance */
	  if(pts_pie_ct->i_for != 0)
		 {
			i_cou =i_cou + (float)1/(float)pts_pie_ct->i_for;
			i_cou_ok =1;
		 }
	}
		if (pts_pie_ct->i_pie_sui==17) break;

	  }
  if(i_cou_ok )
		 {
			i_cou += (tpts_pie[ts_ech[nn].i_cam]+ts_ech[nn].i_Id)->i_for;
		 }

  return i_cou;
}
int ctl_ega (void)
{
  int x;
  /* decide  si doit aller  aux nul :  */
  /* affiner   */
  if (
		(ts_tri_mvt_ini[0].pts_tri_rec)->i_nbr_rep_sit < 1
		||
		ts_tri_mvt_ini[1].pts_tri_rec == NULL
		)

	 return ts_tri_mvt_ini[0].pts_tri_rec->i_num_mvt;

  if (st_eva_sit.i_not_for > FOR_REI + FOR_TOU)
	 {
		for (x=1;ts_tri_mvt_ini[x].pts_tri_rec != NULL;x++)
	{
	  if ( (ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri > - NOT_MAT
			 &&
			 (ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit <1
			 )
		 return (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
		  }
		return (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
	 }
  else
	 {
		if (st_eva_sit.i_not_for > 0 )
	{
	  for (x=1;ts_tri_mvt_ini[x].pts_tri_rec != NULL;x++)
		 {
			if ( (ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri > - NOT_MAT
			&&
			(ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit <1
			)
		return (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
		 }
	  return (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
	}
		else
	{
	  if (st_eva_sit.i_not_for > - FOR_REI)
		 {
			for (x=1;ts_tri_mvt_ini[x].pts_tri_rec != NULL;x++)
		{
		  if ( (ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri > - FOR_TOU
				 &&
				 (ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit <1
				 )
			 return (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
		}
			return (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
		 }
	  else
		 return (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
	}
	 }
}
/*
void ini_tim (int cpt_mvt)
{


}
void maj_tim (int cpt_mvt)
{

}
*/

/*************************************************************************************/
/* Simulation automatique pour comparaison version d'valuation  		     */
/*************************************************************************************/
void sim_aut (void)
{
  int i_mvt_ini; 		/* mvt initial  */
  int i_not_cpt_mvt_ini_sv;     /* Sauvegarde numero mvt initial */

  /* ne pas afficher calcul en cour */
  i_aff_cal_cou = 0;

  /* Choix des versions */
  des_par.ver[0]=1;
  des_par.pf_eva[0] = eva_mei_mvt_test;
  des_par.ver[1]=2;
  des_par.pf_eva[1] = eva_mei_mvt_test;

  /* Choix de la profondeur/incrment  de simulation */
  des_par.pro[BLANC] = 3;
  des_par.inc[BLANC] = 1 ;

  des_par.pro[NOIR ] = 3;
  des_par.inc[NOIR ] = 1 ;

  /* initialisation pour avoir une situation de dpart */
  ini_pgm();

  /* obtenir la liste des mvt initiaux */
  simul(2,0);

  i_not_cpt_mvt_ini_sv =i_not_cpt_mvt_ini;

  /* faire deux parties avec chaque mvt initial */
  for (i_mvt_ini=0; i_mvt_ini <=  i_not_cpt_mvt_ini_sv;i_mvt_ini++)
	 {
		/* joue une partie automatiquement */
		des_par.ver_bla=des_par.ver[0];
		des_par.ver_noi=des_par.ver[1];
		printf("\nMvt ini: %i Vers_blanc: %i",i_mvt_ini,des_par.ver_bla);
		pf_eva_cam[BLANC]= des_par.pf_eva[0];
		pf_eva_cam[NOIR ]= des_par.pf_eva[1];
		jou_par_aut(i_mvt_ini);
		/* joue meme partie en inversant les mthodes d'valuation */
	  des_par.ver_bla=des_par.ver[1];
	  des_par.ver_noi=des_par.ver[0];
		printf("\nMvt ini: %i Vers_blanc: %i",i_mvt_ini,des_par.ver_bla);
		pf_eva_cam[BLANC]= des_par.pf_eva[1];
		pf_eva_cam[NOIR ]= des_par.pf_eva[0];
      jou_par_aut(i_mvt_ini); 

    }

}
/*************************************************************************************/
/* Test  automatique pour detection de bug dans le moteur                            */
/*************************************************************************************/
void test_aut (void)
{
  int i_mvt_ini; 		/* mvt initial  */
  int i_not_cpt_mvt_ini_sv;     /* Sauvegarde numero mvt initial */

  /* ne pas afficher calcul en cour */
  i_aff_cal_cou = 0;

  /* Choix des versions */
  des_par.ver[0]=1;
  des_par.pf_eva[0] = eva_mei_mvt_test;
  des_par.ver[1]=2;
  des_par.pf_eva[1] = eva_mei_mvt_test;

  /* Choix de la profondeur/incrment  de simulation */
  des_par.pro[BLANC] = 3;
  des_par.inc[BLANC] = 1 ;

  des_par.pro[NOIR ] = 3;
  des_par.inc[NOIR ] = 1 ;
  for(;;)
    {
  /* initialisation pour avoir une situation de dpart */
  ini_pgm();

  /* obtenir la liste des mvt initiaux */
  simul(2,0);

  i_not_cpt_mvt_ini_sv =i_not_cpt_mvt_ini;

  /* faire deux parties avec chaque mvt initial */
  for (i_mvt_ini=0; i_mvt_ini <=  i_not_cpt_mvt_ini_sv;i_mvt_ini++)
	 {
		/* joue une partie automatiquement */
		des_par.ver_bla=des_par.ver[0];
		des_par.ver_noi=des_par.ver[1];
		printf("\nMvt ini: %i Vers_blanc: %i",i_mvt_ini,des_par.ver_bla);
		pf_eva_cam[BLANC]= des_par.pf_eva[0];
		pf_eva_cam[NOIR ]= des_par.pf_eva[1];
		jou_par_aut(i_mvt_ini);
		/* joue meme partie en inversant les mthodes d'valuation */
	  des_par.ver_bla=des_par.ver[1];
	  des_par.ver_noi=des_par.ver[0];
		printf("\nMvt ini: %i Vers_blanc: %i",i_mvt_ini,des_par.ver_bla);
		pf_eva_cam[BLANC]= des_par.pf_eva[1];
		pf_eva_cam[NOIR ]= des_par.pf_eva[0];
      jou_par_aut(i_mvt_ini); 

    }
    }
}
int jou_par_aut(int i_mvt_ini)
{
  char nom_fic[30];
  int i_msg=0;
 

  /* rnitialise le pgm et obtenir mvt initiaux */
  ini_pgm();
  simul(2,0);
  /* choisir la 1er version d'valuation du mei_mvt */
  pf_eva = des_par.pf_eva[0];
  /* effectue mvt initial choisi */
  i_msg=jou(
	    ts_not_mvt_ini[i_mvt_ini].i_pos_ori_n,
	    ts_not_mvt_ini[i_mvt_ini].i_pos_arr_n,
	    pro_pio_tra_tmvt_tpie(ts_not_mvt_ini[i_msg].i_typ_mvt)
	    );
  /* commence la parti automatique */
  while ( i_msg >=0 )    
    {	
      /* positionner la version d'valuation */
      pf_eva = pf_eva_cam[ts_hst_pro[i_pro_act+1].i_cam];
      /* positioner la pro.inc de simulation  */
      i_pro_sim_niv = des_par.pro[ts_hst_pro[i_pro_act+1].i_cam];
      i_pro_sim_inc = des_par.inc[ts_hst_pro[i_pro_act+1].i_cam];
      /* simulation */
     i_msg=sim_jou();
     /* printf("Pro: %i",i_pro_act); */

     } 
  /* normalement cela doit se terminer par un mat ou pat!*/
  switch (i_msg)
    {
    case MSG_SIMU_MAT_NOIR :
      des_par.cam_gag='N';
      break;
    case MSG_SIMU_PAT_NOIR :
      des_par.cam_gag='P';
      break;
    case MSG_SIMU_MAT_BLANC :
      des_par.cam_gag='B';
      break;
    case MSG_SIMU_PAT_BLANC :
      des_par.cam_gag='P';
      break;
    case  MSG_JOU_POS_REP_P3F :
      des_par.cam_gag='E';
      break;
    default:
		des_par.cam_gag='-';
	  if(i_msg<0)
	{
	  /*  aff_mes_uti(i_msg);*/
	}

		break;
	 }
  sprintf(nom_fic,"data/PB%u%uPN%u%uVB%02uVN%02uMI%02uGA_%c",
	  des_par.pro[BLANC],
	  des_par.inc[BLANC],
	  des_par.pro[NOIR],
	  des_par.inc[NOIR],
	  des_par.ver_bla,
	  des_par.ver_noi,
	  i_mvt_ini,
	  des_par.cam_gag
	  );
  printf("\t%s",nom_fic);
  sav_dsk(nom_fic);
	return 0;
}
