/* 
    Ec      Copyright (C)   2001 Marc Dechico


    ec_menu.c : Teletyp interface to let the user play
    
     
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

#include "ec_data.h"

/*************************************************/
/* functions prototypes                          */
/*************************************************/

static void mnu_cde (void);

static void 
mnu_cde_prt(char tc_com[80],int *pi_mei_mvt);
static void 
mnu_cde_mov(char tc_com[80]);
static void 
mnu_cde_rec(char tc_com[80],int *pi_mei_mvt);
static void 
mnu_cde_fil(char tc_com[80],int i_cot_aff);

static void 
mnu_hlp (void);

static void 
prt_foo (int i_pro_act,int i_pro_sim_niv,int i_pro_sim_inc);


static void 
aff_nex_pag(void);
static void 
aff_pre_pag(void);

/* affichage de l'chiquier */
static void 
aff_ech (int i_cam);
void 
aff_ech_wra (int i_cam);
static void 
aff_pie (int i_cam);
static void 
aff_pie_lin(int i_pie,struct st_pie *ptst_pie);

static void 
aff_hst (int i_pro_deb, int i_pro_fin);
void 
aff_hst_wra (int i_pro_deb, int i_pro_fin);

/* affichage note */
static int 
aff_not_1 (int *pi_mei_mvt);
static int 
aff_not_2 (int *pi_mei_mvt);
static int 
aff_not_debug (void);

/* affiche un seul mouvement */
static int 
aff_mvt_ini(int i_mvt_ini);

/* gestion interruption simulation */
static void 
sto_sim_msg(void);
void 
sto_sim_msg_wra (void);

/* Affichage calcul en cours */
static void 
aff_cal_en_cou(int i_not_cpt_mvt_ini);
void 
aff_cal_en_cou_wra (int i_not_cpt_mvt_ini);

/* affiche erreur en fin de siulation */
/*void fin_simu_aff_err(int i_err);*/

/* Affichage message  utilisateur  */
static void 
aff_mes_uti(int i_mes_num); 
void 
aff_mes_uti_wra (int i_mes_num); 

/* choix promotion du  pion  */
static char 
pro_pio_cho (void);		 
char 
pro_pio_cho_wra (void);		 
static void 
/* choix version d'valuation */
cho_ver(void);

/* reformatage numrotation scientifique */
static void 
for_nul_sci_nbr (char *); 
static void
print_sci_nbr (float f_nbr);
static void 
sai_com(char *);
static void 
sup_blanc(char *);

/* Change la prfondeur de simulation */
static int 
chg_lvl(char *tc_com);

/* Test  */
static void 
test (void ); 
static void 
test12 (void);


/* Libelle des type de note */
struct { char *label;}
 lib_typ_not []=
{
  { N_("   Mvt_Nbr") },
  { N_("   Mat_Nbr") },
  { N_(" IcMat_Nbr") },
  { N_("   Sta_Nbr") },
  { N_(" IcSta_Nbr") },
  { N_(" RfMat_Nbr") },
  { N_(" RfSta_Nbr") },
  { N_("  Fork_Nbr") },
  { N_("   Pie_Mob") },
  { N_("   Pie_Cov") },
};

/* Separateur*/
static char tc_sep_tir[]="\n-------------------------------------------------------------------------------";
static char tc_sep_tir_120[]="\n-----------------------------------------------------------------------------------------------------------------------";
static char tc_sep_ast[]="\n*******************************************************************************";

/* Pagination pour toutes les fonction d'affichage necessitant plus d'1 page */
static enum {e_pas_aff,e_aff_not_1,e_aff_not_2,st_aff_dim} e_cur_aff;		/* affichage en cours */
struct st_aff
{
  int i_nbr_lig_pag;
  int i_cur_pag;
  int i_fir_pag;
  int i_las_pag;
  int (*pf_aff)();
  void * arguments;
};
static struct st_aff tst_aff[st_aff_dim];

#define TRUE  1
#define FALSE 0

struct option longopts[] =
{
  { "version", no_argument, NULL, 'v' },
  { "help", no_argument, NULL, 'h' },
  { NULL, 0, NULL, 0 }
};

extern char version[];
extern char package[];
extern char package_string[];
extern char package_bugreport[];
extern char package_www[];

static char *progname;


/*****************************************************************************/
/*  Main                                                                     */
/*****************************************************************************/
int
main (argc, argv)
     int argc;
     char *argv[];
{
  int optc;
  int h = 0, v = 0, lose = 0;

  progname = argv[0];

#ifdef HAVE_SETLOCALE
  /* Set locale via LC_ALL.  */
  setlocale (LC_ALL, "");
#endif

#if ENABLE_NLS
  /* Set the text message domain.  */
  bindtextdomain (package, LOCALEDIR);
  textdomain (package);
#endif
  while ((optc = getopt_long (argc, argv, "hmntv", longopts, (int *) 0))
         != EOF)
    switch (optc)
      {
      case 'v':
        v = 1;
        break;
      case 'h':
        h = 1;
        break;
      default:
        lose = 1;
        break;
      }
  
if  (lose || optind < argc)
    {
      /* Print error message and exit.  */
      if (optind < argc)
        fputs (_("Too many arguments\n"), stderr);
      fprintf (stderr, _("Try `%s --help' for more information.\n"), 
               progname);
      exit (1);
    }

 /* `help' should come first.  If `help' is requested, ignore the other
     options. */
  if (h)
    {
      /* Print help info and exit.  */
      /* TRANSLATORS: --help output 1
         no-wrap */
      fputs (_("\
EC Chess Programm.\n"), stdout);
      printf ("\n");
      /* TRANSLATORS: --help output 2
         no-wrap */
      printf (_("\
Usage: %s [OPTION]\n"), progname);

      printf ("\n");
      /* TRANSLATORS: --help output 3 : options 1/2
         no-wrap */
      fputs (_("\
  -h, --help          display this help and exit\n\
  -v, --version       display version information and exit\n"), stdout);

 /* Suppressed: problem with help2man 
      printf ("\n");
      fputs (_("\
Commands to play interactively:\n"), stdout);

      mnu_hlp();
      printf ("\n");
 */      
      printf ("\n");
   
   /* TRANSLATORS: --help output 5 (end)
         TRANSLATORS, please don't forget to add the contact address for
         your translation!
         no-wrap */
      printf (_("\
Report bugs to <%s>.\n"), package_bugreport);

      exit (0);
    }

  if (v)
    {
      /* Print version number.  */
      printf ("%s %s\n", package, version);
      /* xgettext: no-wrap */
      printf ("\n");
      printf (_("\
Copyright (C) %s  Marc Dechico.\n\
There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A\n\
PARTICULAR PURPOSE.  You may redistribute copies of GNU %s under the terms\n\
of the GNU General Public License.\n\
For more information about these matters, see the file named COPYING.\n"),
              "2001", package);
      exit (0);
    }

    mnu_cde();

    return 0;
}
/*****************************************************************************/
/*  test  bug                                                               */
/*****************************************************************************/


static void test6 (void)
{
  /* printf("\n Couverture= %i pour  nn=%i camp=%i",cou_pie(D2,BLANC),D2,BLANC); */
  printf("\n Couverture= %f  camp=%i",eva_cou_cam(BLANC),BLANC); 
  printf("\n Couverture= %f  camp=%i",eva_cou_cam(NOIR),NOIR); 
}
static void test (void)
{
  sim_aut();

}
static void rec_bug(void)
{
  test_aut();
}
static void test7 (void)
{
  char str[10]="         ";
  int i=0;
  int c;

  c=getchar();

  while( i<10) 
    {  
      c=getchar();
      
      if (c !=10 )
	str[i++]=c;
      else 
	break;
    }	
  str[i]='\0';
  printf("\n%s->",str);
  for(i=0;i<10;i++) printf("/%i",str[i]);
}
static void test8 (void)
{
/*
  int i_numfil;
  struct st_rec
  {
    int i_num;
    char tc_rec[20];
  } rec;
  int i_rec;
  int i_pos;
  i_numfil=open("essai",O_RDWR);
  if (i_numfil ==- 1)
    {
      printf("\n cration fichier");
      i_numfil=creat("essai",S_IWUSR|S_IRUSR);
    
    }

  strcpy(rec.tc_rec,"message_1           ");
  rec.i_num=1;
  write(i_numfil,(char *)&rec,20);

  strcpy(rec.tc_rec,"message_2           ");
  rec.i_num=2;
  write(i_numfil,(char *)&rec,20);

  i_rec=1;
  i_pos=i_rec * 20;
  lseek(i_numfil,i_pos,0);
  if(read(i_numfil,(char *)&rec,20)==-1)
    printf("\nerr lec rec: %i",i_rec);
  else
    printf("\nrcd %i : %s",rec.i_num,rec.tc_rec);
  
  
  i_rec=0;
  i_pos=i_rec * 20;
  lseek(i_numfil,i_pos,0);
  if(read(i_numfil,(char *)&rec,20)==-1)
    printf("\nerr lec rec: %i",i_rec);
  else
    printf("\nrcd %i : %s",rec.i_num,rec.tc_rec);
 
  
  close(i_numfil);
  */
}
static void test9 (void)
{
  char c;
  unsigned long x,y=0;
  float  start,end;
  float time;

  /* fflush(stdin);*/
  start =clock();
  for(x=0;x<=100000;x++)
    y=x;
  
    /* printf("\nSaisie");
       c=getchar();*/
 
  end = clock();
  if (start != -1 && end != -1)
    time=(float)(end-start)/(float)CLOCKS_PER_SEC;
  else
    {
      time =0;
      printf("\nErr");
    }
  c=getchar();

  printf("\n char %c start: %e end: %e  CLK_TCK: %lu cpt %lu Time elpsed %e",c,start,end,CLOCKS_PER_SEC,y,time);

}

static void test10 (void)
{
  time_t start,end;
  unsigned long x,y;
  double elapsed;

  start =time (NULL);
  for(x=0;x<=1500000000;x++)
    y=x;

  end = time (NULL);

  elapsed = (double)(end-start);

  printf("\n cpt %li Time elpsed %e",y,elapsed);

}
/*
static void  test11 ()
{
  char c;
  struct timeval td,tf;
  float deb,fin, ela;
  float deb1,fin1, ela1;

  gettimeofday(&td,NULL);
    c=getchar();
    c=getchar();
    gettimeofday(&tf,NULL);
 
    deb = (float)td.tv_sec +( (float)td.tv_usec * (float) 1.0E-6);
    fin = (float)tf.tv_sec +( (float)tf.tv_usec * (float) 1.0E-6);
    ela = fin-deb;

    deb1 = (float)td.tv_sec ;
    fin1 = (float)tf.tv_sec ;

    ela1 = fin1-deb1;

   printf("\nDeb1 %f fin1: %f Elapsed1: %f",deb1,fin1,ela1); 

   printf("\nDeb %f fin: %f Elapsed: %f",deb,fin,ela); 




}
*/
static void test12 (void)
{
  enum e_msg_nbr {MSG_1,MSG_2,MSG_3,MSG_NBR};
  const char *tpc_msg[MSG_NBR+1];
  tpc_msg[MSG_1]="un coup";
  tpc_msg[MSG_2]="une pute";
  tpc_msg[MSG_3]="une somme";
  printf("\n%s",tpc_msg[0]);
}

/*****************************************************************************/
/*  Affichage                                                                */
/*****************************************************************************/

/*  Menu de commande                                                         */

static void mnu_cde (void)
{
  char tc_com[80];
	
  int i_mei_mvt=0;	/* N du meilleur mvt */
  int i_msg=0;              /* message retour de fonction */



  /* initialisation programme */
  ini_pgm();

  /* cote d'affichage */
  i_cot_aff               =  BLANC;

  /*pour sauvegarde et acces autre fct sauf simu qui attend param */
  i_pro_sim_niv	= 3;			/* niveau par default */
  i_pro_sim_inc	= 2;			/* niveau par default */

  printf("%s",tc_sep_tir);
	
  aff_ech(i_cot_aff);

  while (1)
    {
      char c;
      fflush(stdin);
      i_aff_cal_cou 		= 1;

      prt_foo(i_pro_act,i_pro_sim_niv,i_pro_sim_inc);

      sai_com(tc_com);
		
      c=tolower(tc_com[0]);
	
      if (c== '+')
	{
	  aff_nex_pag();
	  continue;
	}
      
      if (c == '-')
	{
	  aff_pre_pag();
	  continue;
	}
               
      if (c ==  (char) *(_("CDE_p")+4) )
	{                  
	  mnu_cde_prt(tc_com, &i_mei_mvt);
	  continue;
	} 	

      if (c == (char) *(_("CDE_m")+4) )
	{                  	
	  mnu_cde_mov(tc_com);
	  continue;
	}

      if (c == (char) *(_("CDE_b")+4) )
	{                  	
	  e_cur_aff=e_pas_aff;
	  i_msg=ann_cou_int();
	  if(i_msg<0)	
	    aff_mes_uti(i_msg);
	  else
	    aff_ech(i_cot_aff);
	  continue;
	}

      if (c == (char) *(_("CDE_r")+4) )
	{                  
	  mnu_cde_rec(tc_com, &i_mei_mvt);
	  continue;
	}

      if (c == (char) *(_("CDE_s")+4) )
	{                   
	  if(i_cot_aff==0)
	    i_cot_aff=1;
	  else
	    i_cot_aff=0;
	  aff_ech(i_cot_aff);
	  continue ;
	}

      if (c == (char) *(_("CDE_l")+4) ) 
	{                  
	  i_msg=chg_lvl(tc_com);
	  if (i_msg<0)
	    aff_mes_uti(i_msg); /* oraganisation */
	  continue ;
	}
			
      if (c == (char) *(_("CDE_f")+4) ) 
	{					
	  mnu_cde_fil(tc_com, i_cot_aff);
	  continue;
	}

      if (c == (char) *(_("CDE_n")+4) )
	{                  
	  e_cur_aff=e_pas_aff;
	  ini_pgm();
	  aff_ech(i_cot_aff);
	  continue;
	}
		  
      if (c == (char) *(_("CDE_?")+4) )
	{                   	
	  mnu_hlp();
	  continue;
	}

      if (c == (char) *(_("CDE_q")+4) )               
	return ;

      if (c == 't')
	{                  
	  e_cur_aff=e_pas_aff;
	  test12() ;
	  continue;
	}

      if (c == 'u') 
	{                   
	  e_cur_aff=e_pas_aff;
	  rec_bug() ;
	  continue;
	}

      if (c == 'x')
	{                  
	  cho_ver() ;
	  continue;
	}

      /* Commande inconnue tapez h pour aide*/
      if(c !='\0')
	{
	  printf(tc_sep_ast );
	  printf("\n");
	  printf( _("Unknown command type ? for help") );
	  printf(tc_sep_ast );
	  printf("\a");
	}	   
    }	 
}

static void 
mnu_cde_prt(char tc_com[80],int *pi_mei_mvt)
{
  int i_mvt = 0;
  int i_msg = 0;
  char c;
 
  c= tolower (tc_com[1]); 
    
  if ( c ==  (char) *(_("CDE_PRT_h")+8) )
    {                  
      e_cur_aff=e_pas_aff;
      aff_hst(i_pro_act,i_pro_sim_max_inf);
      return ;
    }

  if( c ==  '0')
    {                       
      e_cur_aff=e_pas_aff;
      aff_hst(0,i_pro_act);
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_p")+8) ) 
    {                  
      e_cur_aff=e_pas_aff;
      if (tc_com[2]== '0')
	aff_pie(BLANC);
      else
	aff_pie(NOIR);
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_b")+8) )
    {                  
      e_cur_aff=e_pas_aff;
      aff_ech(i_cot_aff);
      return ;
    }

  if( c ==   (char) *(_("CDE_PRT_m")+8) )
    {                  
      char cc;
      cc = tc_com[2];
  
	
      if( cc ==  '1')
	{  
	  e_cur_aff=e_aff_not_1;			
	  i_msg=  aff_not_1(pi_mei_mvt);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);				
	  return ;
	}
      if( cc ==  '2')
	{
	  e_cur_aff=e_aff_not_2;			
	  i_msg=  aff_not_2(pi_mei_mvt);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);			    
	  return ;
	}
      else
	{
	  e_cur_aff=e_aff_not_1;			
	  i_msg=  aff_not_1(pi_mei_mvt);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);			
	  return ; 
	}
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_i")+8) )
    {                  
      e_cur_aff=e_pas_aff;
      if (isdigit(tc_com[2]))
	i_mvt=atoi(&tc_com[2]);
      i_msg = aff_mvt_ini(i_mvt);
      if (i_msg<0) 
	aff_mes_uti(i_msg);			
      return ;
    }
  else
    {    
      mnu_hlp();
      return ;
    }
}	
static void 
mnu_cde_mov(char tc_com[80])
{
  /* argument p:play et m:move */
  char tc_dep[3];               		/* case de depart ex:A1 */
  char tc_arr[4];               		/* case d'arrive ex:B2 ou A8C pour pion en cavalier */

  int i_msg=0;
  char c;

  e_cur_aff=e_pas_aff;
		
  c = tolower (tc_com[1]);
    
    if ( c == (char) *(_("CDE_MOV_m")+8) )
      {              
	/* reponsonce auto de l'ordi */
	if(isdigit(tc_com[2]))
	{
	  /*  une coordonne  pourrait tre confondue avec l'instrution deplace*/
	  strncpy(tc_dep,&tc_com[1],2);
	  strncpy(tc_arr,&tc_com[3],3);
	  i_msg=jou_int_ctl(tc_dep,tc_arr);
	
	}
	else
	{
	  strncpy(tc_dep,&tc_com[2],2);
	  strncpy(tc_arr,&tc_com[4],3);
	  i_msg=jou_int_jou(tc_dep,tc_arr);
	}
      }                	
    else
      {
	/* mouvement sans reponse de l'ordi */	  
	strncpy(tc_dep,&tc_com[1],2);
	strncpy(tc_arr,&tc_com[3],3);             
	i_msg=jou_int_ctl(tc_dep,tc_arr);
      }	
    if (i_msg<0) 
      aff_mes_uti(i_msg);
    aff_ech(i_cot_aff);	
}

static void 
mnu_cde_rec(char tc_com[80],int *pi_mei_mvt)
{
  int i_msg=0;
  char c;

  e_cur_aff=e_pas_aff;
  c = tolower (tc_com[1]);
  /* reckon and move */
  if (c == (char) *(_("CDE_REC_m")+8))                   
    {
      i_msg=sim_jou();
      if(i_msg<0)
	{
	  aff_mes_uti(i_msg);
	}	
							
      aff_ech(i_cot_aff);
    }
  else 
    /* reckon and print */
                    
    {
      *pi_mei_mvt=simul_eva(i_pro_sim_niv,
			    i_pro_sim_inc);
      if (*pi_mei_mvt>=0)
	{
	  e_cur_aff=e_aff_not_1;
	  tst_aff[e_aff_not_1].i_cur_pag=0;
	  i_msg=aff_not_1(pi_mei_mvt);
	  if (i_msg<0) aff_mes_uti(i_msg);
	}
      else
	aff_mes_uti(*pi_mei_mvt);	
    }
}

static void 
mnu_cde_fil(char tc_com[80],int i_cot_aff)
{
  int i_msg;
  char c;
  c=tolower (tc_com[1]);
    
  if ( c == (char) *(_("CDE_FIL_s")+8) )			/* sauvegarde */
    {
      i_msg=sav_dsk("ec.std");
      if(i_msg<0) aff_mes_uti(i_msg);
      return;
    }

  if ( c == (char) *(_("CDE_FIL_l")+8))			/* load */
    {     e_cur_aff=e_pas_aff;
    i_msg=rst_dsk("ec.std");
    if (i_msg<0)
      aff_mes_uti(i_msg);
    else
      aff_ech(i_cot_aff);
    return;
    }
  if (c ==  'w')			/* load  fichier de travail*/
    {
      e_cur_aff=e_pas_aff;
      i_msg=rst_dsk("ec.wrk");
      if(i_msg<0)
	aff_mes_uti(i_msg);
      else
	aff_ech(i_cot_aff);
      return;
    }
}

static void
prt_foo (int i_pro_act,int i_pro_sim_niv,int i_pro_sim_inc)
{
  printf("%s",tc_sep_tir);
  if(i_pro_act>0)
    {
      printf("\n");
      /* Mouvement precedent */
      printf( _("Prv_Mvt:") );
      printf("%s",tc_lib_cas[ts_hst_pro[i_pro_act].i_pos_ori_n]);
      printf("%s",tc_lib_cas[ts_hst_pro[i_pro_act].i_pos_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (ts_hst_pro[i_pro_act].i_typ_mvt));
    }
  else
    {
      printf("\n");
    }
  if(ts_hst_pro[i_pro_act+1].i_cam== BLANC)
    /* Tour au blanc */ 
    printf( _("Turn=White") );
  else
    {
      /* tour au noir */
      printf( _("Turn=Black") );
    }
  printf(" ");
  /* Niveau Increment Cote(machine humain)*/
  printf( _("Curr_Deep=%i Simu=%i.%i") ,
	  i_pro_act,
	  i_pro_sim_niv,
	  i_pro_sim_inc
	  );
  /* Version eva */
  printf (" V:%02u",i_ver_eva);

  /* Aide:tapez h */  
  printf(" ");
  printf( _("Help:Type ?") );
  printf("\n>");

}

static void
cho_ver (void)
{
  int ver;
  scanf("%i",&ver);
  if (tpf_eva[ver] != NULL)
    {
      i_ver_eva = ver;
      pf_eva = tpf_eva[ver];
    }
  else
    printf ("\nErreur Num Evaluation");

}

static int 
chg_lvl(char *tc_com)
{
  int cpt,cpt2;
  char tc_pro_sim[5];
  char tc_pro_sim_inc[5];
  int pro_sim,pro_sim_inc;
  cpt2=0;
  for(cpt=1;cpt < 80 ;cpt++)
    {
      if (tc_com[cpt]=='.')
	{
	  tc_pro_sim[cpt2]='\0';
	  break;
	}
      else
	{
	  tc_pro_sim[cpt2++]=tc_com[cpt];
	}
    }
  pro_sim=atoi(tc_pro_sim);
  /* bug : segmentation fault if 'lw + enter */
  cpt2=0;
  for(cpt=cpt+1;cpt < 80 ;cpt++)
    {
      if (isdigit(tc_com[cpt]))
	{
	  tc_pro_sim_inc[cpt2++]=tc_com[cpt];
	
	}
      else
	{
	  tc_pro_sim_inc[cpt2]='\0';
	  break;
	}
    }
  pro_sim_inc=atoi(tc_pro_sim_inc);

  return (cho_niv(pro_sim,pro_sim_inc));


}
/* affichage aide du menu cde  */
static void 
mnu_hlp (void)
{
  printf( _("\nmove                   : m  A7A8N (N only when pawn promoted to Knight)") );
  printf( _("\nmove and move          : mm A7A8C (the computer replys automatically)") );
  printf( _("\nreckon and move        : rm ") );
  printf( _("\nback                   : b  ") );
  printf( _("\nside                   : s (change side black/white)") );
  printf( _("\nlevel (deepness)       : l 4.2") );
  printf( _("\nfile save              : fs (save game)") );
  printf( _("\nfile load              : fl (load game) ") );
  printf( _("\nnew game               : n") );
  printf( _("\nquit                   : q") );
  printf( _("\nreckon and print marks : r") );
  printf( _("\nprint board            : pb") );
  printf( _("\nprint marKs            : pm ") );
  printf( _("\nprint marKs 2          : pm2 ") );
  printf( _("\nprint initial move     : pi 0 (for the first initial move)") );
  printf( _("\nhelp                   : ? ") );

}
/*  Affichage de l'echiquier */
void 
aff_ech_wra (int i_cam)
{
  aff_ech(i_cam);
}

/*  Affichage de l'echiquier */
static void 
aff_ech (int i_cam)
{
  int x,y;
  int i_pos_n=0;
  int i_lib_lic;
  char b =' ';       /* Case noire	*/
  char n =' ' ;	      /* Case blanche	*/

  int b_n; /* blanc ou noir: 1 ou -1 */
  char c_lib_pie;

  struct { char *label;}
  tc_lib_lic []=
    {
      {package_string},
      /* TRANSLATORS: limit to 40 char to fit a standard screen */
      {N_("Copyright (C) 2001 Marc Dechico")},
 
      {" "},

      {package_bugreport},     

      {package_www},

      {" "},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("There is ABSOLUTELY NO WARRANTY.")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("This is free software, and you are ")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("welcome to redistribute it under the")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("GNU-Licences terms.See the file COPYING.")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("You can contribute to the efforts made") },

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("by the author by sendind encouragment or")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("a crossed check (10 Euros) to :")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       { " " },

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("Marc DECHICO")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("Kerfring")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("29390 SCAER FRANCE")}

    };


  /* pour les noir  (i_cam = 1) les noir sont en bas */
  if (i_cam==NOIR)
    printf("\n | H | G | F | E | D | C | B | A | ");
  else
    printf("\n | A | B | C | D | E | F | G | H | ");

  printf("    %s",_(tc_lib_lic[0].label));
  printf("\n-+===============================+-");
  printf("    %s",_(tc_lib_lic[1].label));
  i_lib_lic = 2;

  if (i_cam == NOIR)
    {
 
      b_n = 1;

	
      for (y=1;y<=8;y++)

	{	
	
	  b_n *=-1;

	  printf("\n%i",y);
	  for (x=8;x>=1;x--)
	    {
	      i_pos_n = (y*10)+x;
	      if (x<8)
		printf("|");
	      else
		printf(":"); 
	      b_n *=-1;
	
	      if(ts_ech[i_pos_n].i_cam<0)
		{
				  
		  if (b_n > 0) printf(" %c ",b);
		  else 		  printf(" %c ",n);
	
		}
	      else
		{
		  c_lib_pie=
		    (tpts_pie[(ts_ech[i_pos_n].i_cam)]
		     +
		     (ts_ech[i_pos_n].i_Id))->c_lib_pie;
		  if (ts_ech[i_pos_n].i_cam== BLANC)
		    printf("(%c)",c_lib_pie);
		  else
		    printf(" %c ",c_lib_pie);

		}

	    }
	  printf(":%i",y);                                
	  if ((i_lib_lic<17 && i_pro_act==0)|| i_lib_lic <5) 	    
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));
	  if (y<8)
	    printf("\n-+ - + - + - + - + - + - + - + - +-"); 
	  if ((i_lib_lic<17 && i_pro_act==0)|| i_lib_lic<5) 
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));

	}
  
    }
  else
    /* pour les blanc (i_cam = BLANC) les blanc sont en bas */
    {


      b_n = 1;
 
      for (y=8;y>=1;y--)
	{
	  b_n *=-1;
	  printf("\n%i",y);
	  for (x=1;x<=8;x++)
	    {
	      i_pos_n= (y*10) + x;
	      if (x>1)
		printf("|");
	      else
		printf(":"); 
	      b_n *=-1;
	
	      if(ts_ech[i_pos_n].i_cam<0)
		{
		  if (b_n > 0) printf(" %c ",b);
		  else 		  printf(" %c ",n);

		}
	      else
		{
		  c_lib_pie=
		    (tpts_pie[(ts_ech[i_pos_n].i_cam)]
		     +
		     (ts_ech[i_pos_n].i_Id))->c_lib_pie;
		  if (ts_ech[i_pos_n].i_cam== BLANC)
		    printf("(%c)",c_lib_pie);
		  else
		    printf(" %c ",c_lib_pie);

		}

	    }
	  printf(":%i",y);
	  if ((i_lib_lic<17 && i_pro_act==0)|| i_lib_lic<5)
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));
	  if (y>1)
	    printf("\n-+ - + - + - + - + - + - + - + - +-");
	  if ((i_lib_lic<17 && i_pro_act==0)|| i_lib_lic<5) 
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));

	}
    }
  printf("\n-+===============================+-");
  if (i_cam==NOIR)
    printf("\n | H | G | F | E | D | C | B | A | ");
  else
    printf("\n | A | B | C | D | E | F | G | H | ");


}

/*  Affichage  piece   */
static void 
aff_pie (int i_cam)
{
  int i_pie ;
  if(i_cam!=0 && i_cam!=1)
    return;
  printf("%s",tc_sep_tir);
  /* \nTableau camp :  %d  */ 
  printf( _("\nSide :  %d") ,i_cam);
  /*  \nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir */
  printf( _("\nId\tnP\tpP\tX\tY\tPwr\tLib\tTdir\tNdir") );
  for (i_pie = 0; i_pie < 18;i_pie++)
    aff_pie_lin(i_pie,tpts_pie[i_cam]+i_pie);
	

}
/*  Affichage  piece presentes   */
static void 
aff_pie_pre (int i_cam)
{
  struct st_pie *pts_pie_ct;
  if(i_cam!=0 && i_cam!=1)
    return;
  printf("%s",tc_sep_tir);
  /* \nTableau camp :  %d  */ 
  printf( _("\nSide :  %d") ,i_cam);
  /*  \nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir */
  printf( _("\nId\tnP\tpP\tX\tY\tPwr\tLib\tTdir\tNdir") );
  pts_pie_ct=tpts_pie[i_cam] ;

  for (	pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
	;
	pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)
    {
      aff_pie_lin(0,pts_pie_ct);
      if (pts_pie_ct->i_pie_sui==17) break;
    }

}
static void 
aff_pie_lin(int i_pie,struct st_pie *ptst_pie)
{
  printf("\n%d\t",i_pie);
  printf("%d\t",ptst_pie->i_pie_sui);
  printf("%d\t",ptst_pie->i_pie_pre);
  printf("%s\t",tc_lib_cas[ptst_pie->i_pos_n]);
  printf("%i\t",ptst_pie->i_for);
  printf("%c\t",ptst_pie->c_lib_pie);

}
/*  Affichage  historique  */
void 
aff_hst_wra (int i_pro_deb, int i_pro_fin)
{ 
  aff_hst(i_pro_deb, i_pro_fin);
}
static void 
aff_hst (int i_pro_deb, int i_pro_fin)
{ 
  /*  Affichage  historique  */
  int pro;
  if (i_pro_fin == 0) i_pro_fin = pts_hst_pro->i_pro;

  printf("%s",tc_sep_tir);
  /* \nTableau historique prof de %d a %d */
  printf( _("\nHistory deepness from %d to %d ") ,i_pro_deb,i_pro_fin);
  /* \nPro\tId\to_x\to_y\tx\ty\tId2 */
  printf( _("\nDee\tId\td_n\tn\tId2") );
  /* \n\tTyp_mvt\tDir_pri\tDir_dem\tDir_dpc */
  printf( _("\n\tMvt_Typ\tMai_Dir\tDir_dem\tDir_dos") );
  /* \n\tNote\tNot max\tPat\tMat */
  printf( _("\n\tMark\tMax Mrk\tPat\tMat") );

  for (pro = i_pro_deb; pro <= i_pro_fin; pro++)
    {
      /*0         1         2         3         4    */
      /*12345678901234567890123456789012345678901234567890*/
      printf(tc_sep_tir);
	
      printf("\n%d\t",pro);

      printf("%c\t",(tpts_pie[ts_hst_pro[pro].i_cam]+ts_hst_pro[pro].i_Id)->c_lib_pie);


		
      printf("%s\t",tc_lib_cas[ts_hst_pro[pro].i_pos_ori_n]);
      printf("%s\t",tc_lib_cas[ts_hst_pro[pro].i_pos_n]);
      printf("%d\t",ts_hst_pro[pro].i_Id_2p);
			
      printf("\n\t");
      printf("%d\t",ts_hst_pro[pro].i_typ_mvt);
			
      printf("%d\t",ts_hst_pro[pro].i_ech_dir_pri);
      printf("%d\t",ts_hst_pro[pro].i_ech_dir_dem);
      printf("%d",ts_hst_pro[pro].i_ech_dir_dem_p_c);
		
      printf("\n\t");
      printf("%d\t",ts_hst_pro[pro].i_not);
      printf("%d\t",ts_hst_pro[pro].i_not_max);
      printf("%d\t",ts_hst_pro[pro].i_pat);
      printf("%d\t",ts_hst_pro[pro].i_mat);
      printf(  "ech:%d\t",ts_hst_pro[pro].i_ech);
      printf("Rf:%d\t",ts_hst_pro[pro].i_rap_for);
      printf("Rpc:%d",ts_hst_pro[pro].i_pos_n_R_p_c);
		
# if CPT_ITE == 1
      printf("cpt:%li",ts_hst_pro[pro].cpt);
# endif
    }

}
/*  Affichage  notes nouvelle version  */
static int 
aff_not_1 (int *pi_mei_mvt)
{
  int i_mei_mvt=*pi_mei_mvt;
  int i_msg;
  int cpt,cpt2;
  int i_fir_lig;
  /* type note  afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc
  };

  ST_NOT_MVT_INI *pts_mvt;
  struct st_aff *pts_aff=&tst_aff[e_aff_not_1];
  pts_aff->i_nbr_lig_pag=8;
  pts_aff->arguments =pi_mei_mvt;
  pts_aff->pf_aff =aff_not_1;

  i_msg=ver_aff_not_pos();
  if(i_msg<0)  return i_msg;		
	
  printf("%s",tc_sep_tir);
  printf("\n");

  /* printf(" N pDeAr Not	"    */
  printf( _(" N pFrTo CapMar S"    ) );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",_(lib_typ_not[te_tn[cpt2]].label));
 


  printf("%s",tc_sep_tir);

  /* dtermine la premire ligne  afficher */
  i_fir_lig = pts_aff->i_nbr_lig_pag *  pts_aff->i_cur_pag
    -
    pts_aff->i_cur_pag ; /*reafficher la dernire ligne */

  for (cpt =i_fir_lig;
       cpt<  i_fir_lig +  pts_aff->i_nbr_lig_pag
	 &&
	 cpt<i_not_cpt_mvt_ini;
       cpt++ )
    {
      pts_mvt = ts_tri_mvt_ini[cpt].pts_tri_rec;
      /* premire ligne */		
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %c",pts_mvt->c_lib_pie);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf( " %i", pts_mvt->i_not_pri);
      printf("\t");
      printf( _("W") );
      for (cpt2=0;cpt2<(int)( sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_cam_bru[BLANC]);
	}

      /* seconde ligne */
      printf("\n\t\t");
      printf( _("B") );
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_cam_bru[NOIR]);
	}
 	
	
    }
  /* mmorise si premire ou drenire page */
  if ((cpt+1)>= i_not_cpt_mvt_ini)  
    pts_aff->i_las_pag=TRUE;

  else
    pts_aff->i_las_pag=FALSE;
  if ( pts_aff->i_cur_pag==0)  
    pts_aff->i_fir_pag=TRUE;
  else
    pts_aff->i_fir_pag=FALSE;

  /* */
  printf("%s",tc_sep_tir);
 
  if(i_mei_mvt>=0)  
    /*printf("\nMei_mvt:%d->%s%s  Piece=%c  Camp=%d Niv=%d,%d ",*/
    printf("\n");

  printf( _("Best_move:%d->%c_%s%s") ,
	  i_mei_mvt,
	  ts_not_mvt_ini[i_mei_mvt].c_lib_pie,
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_ori_n],
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_arr_n]
	  );
  if ( pts_aff->i_las_pag == FALSE)
    /*   printf(" Page suivant: +");*/
    printf( _(" Next_page:+") );
 
  if ( pts_aff->i_fir_pag == FALSE)
    /*  printf(" Page precedent: -");*/
    printf( _(" Previous_page:-") );
 

  return 0;
}

/*  Affichage  notes nouvelle version  */
static int 
aff_not_2 (int *pi_mei_mvt)
{
  int i_mei_mvt=*pi_mei_mvt;
  int i_msg2;
  int cpt,cpt2;
  int i_fir_lig;
  int i_tot_coe;
  /* type note  afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc,
    cou_pie, 
    nbr_fou, 
    mob_pie 	
  };


  ST_NOT_MVT_INI *pts_mvt;

  struct st_aff *pts_aff=&tst_aff[e_aff_not_2];

  pts_aff->i_nbr_lig_pag=10;
  pts_aff->arguments =pi_mei_mvt;
  pts_aff->pf_aff =aff_not_2;
  i_msg2=ver_aff_not_pos();

  if(i_msg2<0)  return i_msg2;		
  printf("%s",tc_sep_tir_120);

  /* Coefficiant */
  printf("\n");
  printf( _("Coefficient") );
  printf("\t");
  i_tot_coe=0;
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    {
      i_tot_coe+= st_eva_sit.ti_coe_pon[te_tn[cpt2]];
      printf(" %9d", st_eva_sit.ti_coe_pon[te_tn[cpt2]]); 
    }
  printf(" %9d", i_tot_coe); 

  /* Entete de colone */
  printf("\n");
  printf( _(" N pFrTo CapMar "    ) );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",_(lib_typ_not[te_tn[cpt2]].label));
  /* Detail par mouvement */ 
  printf("%s",tc_sep_tir_120);
  i_fir_lig = pts_aff->i_nbr_lig_pag *  pts_aff->i_cur_pag
    -
    pts_aff->i_cur_pag ; /*reafficher la dernire ligne */
  for (cpt =i_fir_lig;
       cpt<  i_fir_lig +  pts_aff->i_nbr_lig_pag
	 &&
	 cpt<i_not_cpt_mvt_ini;
       cpt++ )
    {
      pts_mvt = ts_tri_mvt_ini[cpt].pts_tri_rec;
      /* premire ligne */		
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %c",pts_mvt->c_lib_pie);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf( " %i", pts_mvt->i_not_pri);
      printf("\t");
      
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
        print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_dif_pon);
      
      /* seconde ligne */
      printf("\n\t");
      printf("\t");
      
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	printf( "       %3d", pts_mvt->tst_not[te_tn[cpt2]].i_not_pon_rec);
      
      print_sci_nbr(pts_mvt->f_tot_rec_pon);
			
	
    }
  /* mmorise si premire ou drenire page */
  if ((cpt+1)>= i_not_cpt_mvt_ini)  
    pts_aff->i_las_pag=TRUE;
  else
    pts_aff->i_las_pag=FALSE;
  if ( pts_aff->i_cur_pag==0)  
    pts_aff->i_fir_pag=TRUE;
  else
    pts_aff->i_fir_pag=FALSE;

  /* */
  printf("%s",tc_sep_tir_120);

  /* valeur maximum */
  printf("\n");
  printf("%s", _("maximum") );
  printf("\t\t");

  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)	
    print_sci_nbr(st_eva_sit.tst_int_not[te_tn[cpt2]].max);

  /* Valeur minimum */
  printf("\n");
  printf("%s", _("minimum") );
  printf("\t\t");

  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)	
    print_sci_nbr(st_eva_sit.tst_int_not[te_tn[cpt2]].min);

  printf("%s",tc_sep_tir_120);

  if(i_mei_mvt>=0)  
    printf("\n");
  printf( _("Best_move:%d->%c_%s%s") ,
	  i_mei_mvt,
	  ts_not_mvt_ini[i_mei_mvt].c_lib_pie,
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_ori_n],
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_arr_n]	
	  );
  printf("\t\t");
 
  if ( pts_aff->i_las_pag == FALSE)
    printf( _(" Next_page:+") );

  if ( pts_aff->i_fir_pag == FALSE)
    printf( _(" Previous_page:-") );

  return 0;
}


static void 
aff_nex_pag()
{
  struct st_aff *pts_aff=&tst_aff[e_cur_aff];

  if (e_cur_aff != e_pas_aff)
    {
      if ( pts_aff->i_las_pag==FALSE)
	pts_aff->i_cur_pag++;
      else
	printf("\a"); /* alarme */

    }
  else return;
  (*pts_aff->pf_aff)(pts_aff->arguments);
}
static void 
aff_pre_pag()
{
  struct st_aff *pts_aff=&tst_aff[e_cur_aff];
  if (e_cur_aff != e_pas_aff)
    {
      if ( pts_aff->i_fir_pag==FALSE)
	pts_aff->i_cur_pag--;
      else
	printf("\a"); /* alarme */
    }
  else return;
  (*pts_aff->pf_aff)(pts_aff->arguments);

}
static int 
aff_not_debug (void)
{
  int cpt_mvt;
  ST_NOT_MVT_INI *pts_mvt;


  printf("\n%s",tc_sep_tir);
  /* traitement des donnes collectes dans hst */
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
      pts_mvt = &ts_not_mvt_ini[cpt_mvt];
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf("%i",pts_mvt->i_nbr_rep_sit);	
    }
	
  return 0;
}

static int 
aff_mvt_ini(int i_mvt_ini)
{  
  int i_msg;
  int cpt2;
  int p;		/* profondeur */
  ST_NOT_MVT_INI *pts_mvt;
  /* type note  afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mvt,
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc,
    nbr_fou, 
  };


  /* Verification note disponible */
  i_msg=ver_aff_not_pos();
  if(i_msg<0)    return i_msg;

  /* verification existance mvt */
  i_msg=ver_exi_mvt_ini(i_mvt_ini);
  if(i_msg<0)    return i_msg;

  pts_mvt = &ts_not_mvt_ini[i_mvt_ini];  

  /* Affichage mvt */
  /*"Num:%i  Mvt:%c %s%s"*/
  printf( _("Number:%i Movement:%c %s%s") , 
	  i_mvt_ini,
	  pts_mvt->c_lib_pie,
	  tc_lib_cas[pts_mvt->i_pos_ori_n],
	  tc_lib_cas[pts_mvt->i_pos_arr_n]
	  );

  /* affichage entete de colone */
  printf("%s",tc_sep_tir);
  printf("\n");
  /*   printf(" p I C ");*/
  printf( _(" D I  S") );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",_(lib_typ_not[te_tn[cpt2]].label));


  printf("%s",tc_sep_tir);

  /*affichage du dtail par profondeur */

  for(p=0;p< (pts_mvt->i_pro_sim+pts_mvt->i_inc_pro_sim-1);p++)
    {
      printf("\n");
      printf ("%2i ",p+2);
      printf ("%i  ", tst_pro_sta[pts_mvt->i_num_mvt][p].i_inc);
      if ( tst_pro_sta[pts_mvt->i_num_mvt][p].i_cam == BLANC)
	printf ( _("W") );
      else
	printf ( _("B") );
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr(  tst_pro_sta[pts_mvt->i_num_mvt][p].f_dat_pro[te_tn[cpt2]]);
	}


    }
  return 0;
}

/* Affichage calcul en cours */
void 
aff_cal_en_cou_wra (int i_not_cpt_mvt_ini)
{
  aff_cal_en_cou(i_not_cpt_mvt_ini);
}
static void 
aff_cal_en_cou(int i_not_cpt_mvt_ini)
{
  if(i_aff_cal_cou == 1 )
    {
#if CPT_ITE == 1
      printf("\nmvt %s%s  num:%i cpt_ite:%li",
	     tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_n],
	     tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_n],
	     i_not_cpt_mvt_ini,
	     cpt);
#else
      printf("\nnum:");
      printf("%2i: ",i_not_cpt_mvt_ini);
      printf(" mvt:");
      printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_n]);
      printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_n]);
	
#endif
    }
}

void 
sto_sim_msg_wra (void)
{	
  sto_sim_msg();
}
static void 
sto_sim_msg(void)
{
  fflush(stdin);
  /* \nVoulez vous interrompre le calcul? (O/N) */
  printf(tc_sep_ast);
  printf("\n");
  printf( _("Dou you want to stop the computation ? (y/n)") );
  printf(tc_sep_ast);
  printf("\n");
  /* getchar();*/
  if( tolower(getchar()) == (char) *(_("y")) )
    sto_sim();
  else
    i_sto_sim_cla = 0;
}

/* Choix remplacement du pion */
/* Verifie si piece de promotion est ok sinon demande interactive */
/* et traduction lib piece vers type piece */

char 
pro_pio_cho_wra (void)
{
  return pro_pio_cho();
}
static char 
pro_pio_cho (void)
{
  int i_msg=0;
  int c;

  /* c=getchar();  bricolage! */
  /* Quelle piece voulez vous pour remplacer le pion? */
  printf(tc_sep_ast);
  printf("\n");
  printf( _("Which piece for the pawn's promotion ? ") );
  printf(tc_sep_ast);
  printf("\n");
      
  while (1)
    {
      fflush(stdin);

      c=getchar();
	  
      i_msg=pro_pio_ver_lib_pie(c);

      if(i_msg>=0)
	return (pro_pio_tra_lpie_tpie(c));
      else
	aff_mes_uti(i_msg);
      printf("\n");
	   
    }
 
}

/* Affichage message utilisateur  */
void 
aff_mes_uti_wra (int i_mes_num)
{	
  aff_mes_uti(i_mes_num);
}
static void 
aff_mes_uti(int i_mes_num)
{
  /*recupere le texte du message */
  char tc_lib_mes[LEN_MES];
  cha_mes (i_mes_num, tc_lib_mes);
 

  printf("%s",tc_sep_ast);
  printf("\n%s",tc_lib_mes);

  printf("%s",tc_sep_ast);
  printf("\a"); /* alarme */
}
static void 
for_nul_sci_nbr (char *str)  
{
  /* si valeur nulle supprime la notation sciatifique */
  if (strcmp(str,"+0.00e+00")==0)
    strcpy(str,  "        0");
}
static void 
print_sci_nbr (float f_nbr)
{
  /* Imprime un nombre de type float 
     si la vlaeur = 0 supprime la notation scientifique */ 
  char tc_nbr[11]; 
  sprintf(tc_nbr,"%+2.2e",f_nbr);
  for_nul_sci_nbr(tc_nbr);
  printf(" %s",tc_nbr);
}
static void 
sup_blanc(char *tc_str)
{
  /* supprime les blanc de la zone de saisie */
  int i=0;
  int ii=0;
  for(i=0;i<=(int)strlen(tc_str);i++)
    {   
      if(tc_str[i]!=' ')
	{
	  tc_str[ii++]=tc_str[i];
	}
    }
  tc_str[ii]='\0';
}
static void 
sai_com (char tc_com [80])
{
  int i=0;
  int c;
  
  while(1) 
    {  
      c=getchar();
      
      if (c !=10 && i<78 )
	tc_com[i++]=c;
      else 
	break;
    }	
  tc_com[i]='\0';
  sup_blanc(tc_com);

}

#ifdef C_ALLOCA /* xmalloc() is only used by alloca.c.  */

char *
xmalloc (size)
     unsigned int size;
{
  char *ptr = malloc (size);
  if (! ptr)
    {
      fprintf (stderr, _("%s: Virtual memory exhausted\n"), progname);
      exit (1);
    }
  return ptr;
}
#endif /* C_ALLOCA */

