/* 
    Ec     Copyright (C)   2001 Marc Dechico
    
    ec_mvt_g.c : create includes files that are used to 
                 create const table (pointer for functions)
		 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/


/****************************************************************/
/* ec_da_cst_mvt_roi.c 						*/
/* generation d'un source contenant less lements de la 	*/
/* table pttpf_mvt_roi []					*/
/* le fichier de sortie doit tre trie				*/
/* la virgule enleve sur la drenire ligne du fichier trier 	*/
/****************************************************************/

#include	<config.h>
#include	<stdio.h>
#include	"ec_defin.i"
FILE *pf_std;
void wr(int nn,char *str);
void wr_99(int nn,char *str);

int  ext (void); /* case exterieur */
int  roi (void);
int  rei (void);
int  fou (void);
int  tou (void);
int  cav (void);
int  pio_0 (void);
int  pio_1 (void);

int main (void)
{
  roi();
  rei();
  fou();
  tou();
  cav();
  pio_0();
  pio_1();
}
int ext (void)
{
  int x,y,nn;
  /* case exterieur bas */
  for (x=0;x<10;x++)
    { 
      nn= (0*10) + x;
      wr(nn,"NULL");
    }

  /* case exterieur haut */
  for (x=0;x<9;x++)
    { 
      nn= (9*10) + x;
      wr(nn,"NULL");
    }
 /* case 99 */
  wr_99(99,"NULL");

  /* case exterieur droit sauf 99 */
  for (y=1;y<9;y++)
    { 
      nn= (y*10) + 9;
      wr(nn,"NULL");
    }
  /* case exterieur gauche */
  for (y=1;y<9;y++)
    { 
      nn= (y*10) + 0;
      wr(nn,"NULL");
    }
 }
void wr(int nn,char *str)
{
  
  fprintf(pf_std,"/* %02i */ %s,\n",nn,str);
	
}
void wr_99(int nn,char *str)
{
  
  fprintf(pf_std,"/* %02i */ %s\n",nn,str);
	
}

int  roi(void)
{
  int x,y,nn;

  if ( (pf_std= fopen("ec_mvt_r.ii","w")) !=NULL )
    {
      /* exterieur de l'chiquier */
      ext();
      /* bord de l'echiquier */   
      wr(A1,"tpf_roi_b_g");
      wr(H1,"tpf_roi_b_d");
      wr(A8,"tpf_roi_h_g");
      wr(H8,"tpf_roi_h_d");

      for (y=2;y<=7;y++)
	{
	  nn= (y*10) + A;
	  wr(nn,"tpf_roi_g");
	}
      for (x=B;x<=G;x++)
	{
	  nn=(8*10) + x;
	  if (nn==E8)
	    wr(E8, "tpf_roi_pos_ori_1");	/* pour gestion du rock */
	  else
	    wr(nn,"tpf_roi_h");
	}
 
      /* pas de bug: si un roi retrouve  la place de l'autre alors plus de rock possible
	 pour l'un et l'autre */
      /* opt : dans ce cas inutile d'appeller les fcts rock, mais comment? */

      for (y=2;y<=7;y++)
	{
	  nn=(y*10) + H;
	  wr(nn,"tpf_roi_d");
	}
      for (x=B;x<=G;x++)
	{
	  nn=(1*10) + x;
	  if (nn == E1)
	    wr(E1, "tpf_roi_pos_ori_0"); /* pour gestion du rock */
	  else
	    wr(nn,"tpf_roi_b");
	}


      /* centre */
      for (x=B;x<=G;x++)
	{
	  for (y=2;y<=7;y++)
	    {
	      nn= (y*10) + x;
	      wr(nn,"tpf_roi_nor");
	    }
	}


      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      printf("\nErreur d'criture ");
      return -1;
    }
  return 0;
}

int  rei(void)
{
  int x,y,nn;

  if ( (pf_std= fopen("ec_mvt_d.ii","w")) !=NULL )
    {
      /* exterieur de l'chiquier */
      ext();

      /* case exterieur */
      wr(A1,"tpf_rei_b_g");
      wr(A8,"tpf_rei_h_g");
      wr(H8,"tpf_rei_h_d");
      wr(H1,"tpf_rei_b_d");

      for (y=2;y<=7;y++)
	{
	  nn=(y*10) + A;
	  wr(nn,"tpf_rei_g");
	}
      for (x=B;x<=G;x++)
	{
	  nn=(8*10) + x;
	  wr(nn,"tpf_rei_h");
	}
      for (y=2;y<=7;y++)
	{
	  nn=(y*10) + H;
	  wr(nn,"tpf_rei_d");
	}
      for (x=2;x<=7;x++)
	{
	  nn=(1*10) + x;
	  wr(nn,"tpf_rei_b");
	}

      /* centre */
      for (x=B;x<=G;x++)
	{
	  for (y=2;y<=7;y++)
	    {
	      nn=(y*10) + x;
	      wr(nn,"tpf_rei_nor");
	    }
	}

      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      printf("\nErreur d'criture ");
      return -1;
    }
  return 0;
}
int  fou(void)
{
  int x,y,nn;

  if ( (pf_std= fopen("ec_mvt_f.ii","w")) !=NULL )
    {
      /* exterieur de l'chiquier */
      ext();
      /* initialisation ptr tbl ptr fou selon position */
      /* case exterieur */
      wr(A1,"tpf_fou_b_g");
      wr(A8,"tpf_fou_h_g");
      wr(H8,"tpf_fou_h_d");
      wr(H1,"tpf_fou_b_d");

      for (y=2;y<=7;y++)
	{
	  nn=(y*10)+ A;
	  wr(nn,"tpf_fou_g");
	}
      for (x=B;x<=G;x++)
	{
	  nn= (8*10)+x;
	  wr(nn,"tpf_fou_h");
	}
      for (y=2;y<=7;y++)
	{
	  nn=(y*10) + H;
	  wr(nn,"tpf_fou_d");
	}
      for (x=B;x<=G;x++)
	{
	  nn=(1*10) + x;
	  wr(nn,"tpf_fou_b");
	}

      /* centre */
      for (x=B;x<=G;x++)
	{
	  for (y=2;y<=7;y++)
	    {
	      nn=(y*10) + x;
	      wr(nn,"tpf_fou_nor");
	    }
	}


      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      printf("\nErreur d'criture ");
      return -1;
    }
  return 0;
}

int  tou(void)
{
  int x,y,nn;

  if ( (pf_std= fopen("ec_mvt_t.ii","w")) !=NULL )
    {
      /* exterieur de l'chiquier */
      ext();
 /* initialisation ptr tbl ptr et nbr dir tour selon position */
	 /* case exterieur */
	wr(A1,"tpf_tou_b_g");
	wr(A8,"tpf_tou_h_g");
	wr(H8,"tpf_tou_h_d");
	wr(H1,"tpf_tou_b_d");

	 for (y=2;y<=7;y++)
	 {
	   nn=(y*10) + A;
	  wr(nn,"tpf_tou_g");
	 }
	 for (x=B;x<=G;x++)
	 {
	   nn=(8*10) + x;
	  wr(nn,"tpf_tou_h");
	 }
	 for (y=2;y<=7;y++)
	 {
	   nn=(y*10) + H;
	  wr(nn,"tpf_tou_d");
	 }
	 for (x=B;x<=G;x++)
	 {
	   nn= (1*10) + x;
	  wr(nn,"tpf_tou_b");
	 }

	 /* centre */
	 for (x=B;x<=G;x++)
	 {
		 for (y=2;y<=7;y++)
		 {
		   nn=(y*10) + x;
		  wr(nn,"tpf_tou_nor");
		 }
	 }

      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      printf("\nErreur d'criture ");
      return -1;
    }
  return 0;
}

int  cav(void)
{
  int x,y,nn;

  if ( (pf_std= fopen("ec_mvt_c.ii","w")) !=NULL )
    {
      /* exterieur de l'chiquier */
      ext();
	/* initialisation ptr tbl ptr et nbr dir cavalier selon position */
	 /* case exterieur */
	wr(A1,"tpf_cav_c_b_g");
	wr(H1,"tpf_cav_c_b_d");
	wr(A8,"tpf_cav_c_h_g");
	wr(H8,"tpf_cav_c_h_d");

	wr(A2,"tpf_cav_g_b");
	wr(A7,"tpf_cav_g_h");
	wr(B8,"tpf_cav_h_g");
	wr(G8,"tpf_cav_h_d");
	wr(H7,"tpf_cav_d_h");
	wr(H2,"tpf_cav_d_b");
	wr(G1,"tpf_cav_b_d");
	wr(B1,"tpf_cav_b_g");

	 for (y=3;y<=6;y++)
	 {
	   nn=(y*10) + A;
	
		wr(nn,"tpf_cav_g");
	 }
	 for (x=3;x<=6;x++)
	 {
	   nn=(8*10) + x;
	
		wr(nn,"tpf_cav_h");
	 }
	 for (y=3;y<=6;y++)
	 {
	   nn=(y*10) +H;
	
		wr(nn,"tpf_cav_d");
	 }
	 for (x=3;x<=6;x++)
	 {
	   nn=(1*10) + x;
	
		wr(nn,"tpf_cav_b");
	 }

	 /* case interieur */
	wr(B2,"tpf_cav_i_c_b_g");
	wr(B7,"tpf_cav_i_c_h_g");
	wr(G7,"tpf_cav_i_c_h_d");
	wr(G2,"tpf_cav_i_c_b_d");

	 for (y=3;y<=6;y++)
	 {
	   nn=(y*10)+ B;
	  wr(nn,"tpf_cav_i_g");
	 }
	 for (x=C;x<=F;x++)
	 {
	   nn=(7*10)+ x;
	  wr(nn,"tpf_cav_i_h");
	 }
	 for (y=3;y<=6;y++)
	 {
	   nn= (y*10) + G;
	  wr(nn,"tpf_cav_i_d");
	 }
	 for (x=C;x<=F;x++)
	 {
	   nn=(2*10) + x;
	  wr(nn,"tpf_cav_i_b");
	 }
	 /* centre */
	 for (x=C;x<=F;x++)
	 {
		 for (y=3;y<=6;y++)
		 {
		   nn=(y*10) + x;
		  wr(nn,"tpf_cav_nor");
		 }
	 }

      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      printf("\nErreur d'criture ");
      return -1;
    }
  return 0;
}
int pio_0 (void)
{
  int x,y,nn;

  if ( (pf_std= fopen("ec_mvtp0.ii","w")) !=NULL )
    {
      /* exterieur de l'chiquier */
      ext();
      /* initialisation ptr tbl ptr mvt selon position pour pion blanc */
      /* ligne 1, 8 jammais occup par un piont blanc  */
      for (x=A;x<=H;x++)
	{
	  nn=(1*10) + x;
	  wr(nn,"NULL");
	  nn=(8*10) + x;
	  wr(nn,"NULL");
	}

      /* ligne 2  */
      wr(A2,"tpf_pio_0_L2_g");
      wr(H2,"tpf_pio_0_L2_d");

      for (x=B;x<=G;x++)
	{
	  nn=(2*10) + x;
	  wr(nn,"tpf_pio_0_L2");
	}
      /* ligne 3,4,6 */
      wr(A3,"tpf_pio_0_L346_g");
      wr(H3,"tpf_pio_0_L346_d");

      for (x=B;x<=G;x++)
	{
	  nn=(3*10) + x;
	  wr(nn,"tpf_pio_0_L346");
	}
      wr(A4,"tpf_pio_0_L346_g");
      wr(H4,"tpf_pio_0_L346_d");

      for (x=B;x<=G;x++)
	{
	  nn=(4*10) + x;
	  wr(nn,"tpf_pio_0_L346");
	}
      wr(A6,"tpf_pio_0_L346_g");
      wr(H6,"tpf_pio_0_L346_d");

      for (x=B;x<=G;x++)
	{
	  nn=(6*10) + x;
	  wr(nn,"tpf_pio_0_L346");
	}
      /* ligne 5 */
      wr(A5,"tpf_pio_0_L5_g");
      wr(H5,"tpf_pio_0_L5_d");

      for (x=B;x<=G;x++)
	{
	  nn=(5*10) + x;
	  wr(nn,"tpf_pio_0_L5");
	}
      /* ligne 7 */
      wr(A7,"tpf_pio_0_L7_g");
      wr(H7,"tpf_pio_0_L7_d");

      for (x=B;x<=G;x++)
	{
	  nn=(7*10) + x;
	  wr(nn,"tpf_pio_0_L7");
	}
      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      printf("\nErreur d' criture ");
      return -1;
    }
  return 0;
}

int pio_1 (void)
{
  int x,y,nn;

  if ( (pf_std= fopen("ec_mvtp1.ii","w")) !=NULL )
    {
      /* exterieur de l'chiquier */
      ext();

      /* initialisation ptr tbl ptr mvt selon position pour pion noir */
      /* ligne 8, 1 jammais occup par un piont noir  */
      for (x=A;x<=H;x++)
	{
	  nn=(1*10) + x;
	  wr(nn,"NULL");
	  nn=(8*10) + x;
	  wr(nn,"NULL");
	}

      /* ligne 7  */
      wr(A7,"tpf_pio_1_L7_g");
      wr(H7,"tpf_pio_1_L7_d");

      for (x=B;x<=G;x++)
	{
	  nn=(7*10)+ x;
	  wr(nn,"tpf_pio_1_L7");
	}
      /* ligne 6,5,3 */
      wr(A6,"tpf_pio_1_L653_g");
      wr(H6,"tpf_pio_1_L653_d");

      for (x=B;x<=G;x++)
	{
	  nn=(6*10)+x;
	  wr(nn,"tpf_pio_1_L653");
	}
      wr(A5,"tpf_pio_1_L653_g");
      wr(H5,"tpf_pio_1_L653_d");

      for (x=B;x<=G;x++)
	{
	  nn=(5*10)+x;
	  wr(nn,"tpf_pio_1_L653");
	}
      wr(A3,"tpf_pio_1_L653_g");
      wr(H3,"tpf_pio_1_L653_d");
      for (x=B;x<=G;x++)
	{
	  nn=(3*10)+x;
	  wr(nn,"tpf_pio_1_L653");
	}
      /* ligne 4 */
      wr(A4,"tpf_pio_1_L4_g");
      wr(H4,"tpf_pio_1_L4_d");

      for (x=B;x<=G;x++)
	{
	  nn=(4*10)+x;
	  wr(nn,"tpf_pio_1_L4");
	}
      /* ligne 2 */
      wr(A2,"tpf_pio_1_L2_g");
      wr(H2,"tpf_pio_1_L2_d");

      for (x=B;x<=G;x++)
	{
	  nn=(2*10)+x;
	  wr(nn,"tpf_pio_1_L2");
	}
      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      printf("\nErreur d' criture ");
      return -1;
    }
  return 0;
}

